# TODO:
# - build py2 and py3 variants both?

#
# Conditional build:
%bcond_with	python3	# use CPython 3.x

%define		mod_name	wsgi
%define 	apxs		/usr/sbin/apxs
Summary:	WSGI interface for the Apache Web server
Summary(pl.UTF-8):	Interfejs WSGI dla serwera WWW Apache
Name:		apache-mod_%{mod_name}
Version:	3.5
Release:	1
License:	Apache
Group:		Networking/Daemons
# Source0:	http://modwsgi.googlecode.com/files/mod_%{mod_name}-%{version}.tar.gz
# https://github.com/GrahamDumpleton/mod_wsgi/archive/3.5.tar.gz
Source0:	https://github.com/GrahamDumpleton/mod_wsgi/archive/%{version}.tar.gz
# Source0-md5:	ed08ce86cf34a60441b708db05da970f
Source1:	%{name}.conf
URL:		http://code.google.com/p/modwsgi/
BuildRequires:	%{apxs}
BuildRequires:	apache-devel >= 2.0.52-7
BuildRequires:	apr-devel >= 1:1.0.0
BuildRequires:	autoconf
BuildRequires:	automake
%if %{with python3}
BuildRequires:	python3-devel
%else
BuildRequires:	python-devel >= 2.3
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
Requires:	apache(modules-api) = %{apache_modules_api}
Requires:	apr >= 1:1.0.0
# http://helpful.knobs-dials.com/index.php/Mod_wsgi_notes#PyEval_AcquireThread:_non-NULL_old_thread_state
Conflicts:	apache-mod_python
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		apacheconfdir	%(%{apxs} -q SYSCONFDIR 2>/dev/null)/conf.d
%define		apachelibdir	%(%{apxs} -q LIBEXECDIR 2>/dev/null)

%description
The mod_wsgi adapter is an Apache module that provides a WSGI
compliant interface for hosting Python based web applications within
Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower
overhead than using existing WSGI adapters for mod_python or CGI.

%description -l pl.UTF-8
Adapter mod_wsgi jest modułem udostępniającym interfejs WSGI dla
aplikacji WWW napisanych w języku Python i osadzonych w serwerze
Apache. Adapter jest w całości napisany w języku C w oparciu o
bibliotekę uruchomieniową Apache i ma mniejsze wymagania niż w
przypadku używania istniejących adapterów WSGI dla modułu mod_python
lub CGI.

%prep
%setup -q -n mod_%{mod_name}-%{version}

%build
%{__aclocal}
%{__autoconf}
%if %{with python3}
PYTHONBIN=%{__python3}
%else
PYTHONBIN=%{__python}
%endif
%configure \
	--with-apxs=%{apxs} \
	--with-python=$PYTHONBIN

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{apachelibdir},%{apacheconfdir}}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

cp -p %{SOURCE1} $RPM_BUILD_ROOT%{apacheconfdir}/61_mod_wsgi.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
%service -q httpd restart

%postun
if [ "$1" = "0" ]; then
	%service -q httpd restart
fi

%files
%defattr(644,root,root,755)
%doc README
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{apacheconfdir}/*_mod_%{mod_name}.conf
%attr(755,root,root) %{apachelibdir}/*.so
%changelog
* Wed May 21 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/apache-mod_wsgi.git;a=log;h=master

* Wed May 21 2014 Mateusz Korniak <matkor@pld-linux.org> 43d2bec
- Version 3.5-1. Security update (CVE-2014-0240)

* Wed Aug 07 2013 Mateusz Korniak <matkor@pld-linux.org> 21e75ee
- Release 4. Rebuild to silence apache warnings about build/runtime python versions.

* Thu Apr 25 2013 Elan Ruusamäe <glen@delfi.ee> 25f08ef
- rel 3

* Thu Apr 25 2013 Elan Ruusamäe <glen@delfi.ee> 7d47fcb
- conflict with mod_python

* Thu Apr 25 2013 Elan Ruusamäe <glen@delfi.ee> 637022b
- drop cvs leftovers

* Fri Apr 12 2013 Łukasz Kieś <kiesiu@pld-linux.org> 1d03b17
- release 2 (by relup.sh)

* Wed Feb 06 2013 Elan Ruusamäe <glen@delfi.ee> cd06f81
- up to 3.4, adds WSGIEnableSendfile and more improvements

* Wed Sep 15 2010 Mateusz Korniak <matkor@pld-linux.org> 57018de
- Version 3.3. Release 1.

* Thu Jul 08 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 56341e5
- release 2

* Thu Mar 11 2010 Artur Frysiak <artur@frysiak.net> 277dec4
- up to 3.2
- added python3 bcond

* Sat May 23 2009 Artur Frysiak <artur@frysiak.net> 7d252d8
- updated to 2.5

* Fri Mar 13 2009 hawk <hawk@pld-linux.org> b473e0c
- release 2

* Tue Feb 03 2009 duddits <duddits@pld-linux.org> 3cc406f
- up to 2.3

* Fri Oct 03 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> c052c3a
- release 3

* Sat Feb 09 2008 Jakub Bogusz <qboosh@pld-linux.org> e606faa
- unified License format

* Sat Jan 05 2008 Jakub Bogusz <qboosh@pld-linux.org> db2bc9e
- pl fixes

* Wed Dec 26 2007 Elan Ruusamäe <glen@pld-linux.org> 06cca75
- remove compile time apache daemon requirement

* Wed Dec 26 2007 Elan Ruusamäe <glen@pld-linux.org> 198257b
- use conf.d for apache config fragment; rel 2

* Sun Dec 09 2007 Elan Ruusamäe <glen@pld-linux.org> dc5b014
- apache-apxs -> %{apxs} in BR

* Fri Oct 05 2007 Patryk Zawadzki <patrys@room-303.com> c1cb356
- initial PLD release
- provided by Kamil Jakubowski <jakubowski.kamil@3vnet.pl>
- adapterized

